/************************** DISCLAIMER ********************************/
/*                                                                    */
/*   This file was generated on 03/22/01 09:36:03 by the version of   */
/*   ADIC compiled on  08/07/00 18:06:31                              */
/*                                                                    */
/*   ADIC was prepared as an account of work sponsored by an          */
/*   agency of the United States Government and the University of     */
/*   Chicago.  NEITHER THE AUTHOR(S), THE UNITED STATES GOVERNMENT    */
/*   NOR ANY AGENCY THEREOF, NOR THE UNIVERSITY OF CHICAGO, INCLUDING */
/*   ANY OF THEIR EMPLOYEES OR OFFICERS, MAKES ANY WARRANTY, EXPRESS  */
/*   OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR */
/*   THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION OR  */
/*   PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT INFRINGE */
/*   PRIVATELY OWNED RIGHTS.                                          */
/*                                                                    */
/**********************************************************************/
#include "ad_deriv.h"
#include <stdio.h>
#include <stdlib.h>
typedef double nosens_real;
typedef DERIV_TYPE  ad_real;
typedef int  integer;
#include "ad_mpi.h"
#define PVEC_REAL_MPI_TYPE MPI_DERIV_TYPE
void   *ad_PVecInitMPI(MPI_Comm  comm,int  local_vec_length,int  global_vec_length,int  *argc,char  ***argv);
void   ad_PVecFreeMPI(void   *machEnv);
struct ad_machEnvTypeStruct {
MPI_Comm  comm;
integer  local_vec_length;
integer  global_vec_length;
int  init_by_user;
}
;
typedef struct ad_machEnvTypeStruct *machEnvType;
typedef struct  {
integer  length;
integer  global_length;
DERIV_TYPE  *data;
machEnvType  machEnv;
void   *subptr;
}
*ad_N_Vector;
ad_N_Vector  ad_N_VNew(integer  Ntotal,machEnvType  machEnv);
void   ad_N_VFree(ad_N_Vector  x);
void   ad_N_VLinearSum(DERIV_TYPE  a,ad_N_Vector  x,DERIV_TYPE  b,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VConst(DERIV_TYPE  c,ad_N_Vector  z);
void   ad_N_VProd(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VDiv(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
void   ad_N_VScale(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VAbs(ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VInv(ad_N_Vector  x,ad_N_Vector  z);
void   ad_N_VAddConst(ad_N_Vector  x,DERIV_TYPE  b,ad_N_Vector  z);
void   ad_N_VDotProd(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  y);
void   ad_N_VMaxNorm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VWrmsNorm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  w);
void   ad_N_VMin(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VWL2Norm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x,ad_N_Vector  w);
void   ad_N_VL1Norm(DERIV_TYPE  *ad_var_ret,ad_N_Vector  x);
void   ad_N_VCompare(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  z);
int  ad_N_VInvTest(ad_N_Vector  x,ad_N_Vector  z);
int  ad_N_VConstrProdPos(ad_N_Vector  c,ad_N_Vector  x);
void   ad_N_VPrint(ad_N_Vector  x);
void   ad_UnitRoundoff(DERIV_TYPE  *ad_var_ret);
void   ad_RPowerI(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  base,int  exponent);
void   ad_RPowerR(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  base,DERIV_TYPE  exponent);
void   ad_RSqrt(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  x);
static void   ad_PVecAllReduce(DERIV_TYPE  *ad_var_ret,DERIV_TYPE  d,int  op,machEnvType  machEnv);
static void   ad_VCopy(ad_N_Vector  x,ad_N_Vector  z);
static void   ad_VSum(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_VDiff(ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_VNeg(ad_N_Vector  x,ad_N_Vector  z);
static void   ad_VScaleSum(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_VScaleDiff(DERIV_TYPE  c,ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_VLin1(DERIV_TYPE  a,ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_VLin2(DERIV_TYPE  a,ad_N_Vector  x,ad_N_Vector  y,ad_N_Vector  z);
static void   ad_Vaxpy(DERIV_TYPE  a,ad_N_Vector  x,ad_N_Vector  y);
static void   ad_VScaleBy(DERIV_TYPE  a,ad_N_Vector  x);
void   *ad_PVecInitMPI(MPI_Comm  comm,integer  local_vec_length,integer  global_vec_length,int  *argc,char  ***argv) {
int  initflag, initerr;
integer  n, Nsum;
machEnvType  env;
void   *ad_var_0, *ad_var_2, *ad_var_3, *ad_var_5, *ad_var_6, *ad_var_9;
machEnvType  ad_var_1;
int  ad_var_4;
MPI_Datatype  ad_var_7;
ad_MPI_Op  ad_var_8;
    ad_var_0 = malloc( sizeof (struct ad_machEnvTypeStruct ));
    ad_var_1 = (machEnvType )ad_var_0;
    env = ad_var_1;
    ad_var_2 = (void  * )0;
    if (env == ad_var_2)     {
        ad_var_3 = (void  * )0;
        return ad_var_3;
    }
    env->local_vec_length = local_vec_length;
    env->global_vec_length = global_vec_length;
    MPI_Initialized( &initflag);
    if ( !initflag)     {
        ad_var_4 = ad_MPI_Init(argc, argv);
        initerr = ad_var_4;
        if (initerr != 0)         {
            ad_var_5 = (void  * )0;
            return ad_var_5;
        }
    }
    env->init_by_user = initflag;
    ad_var_6 = (void  * )0;
    env->comm = comm == ad_var_6? 91 : comm;
    if (local_vec_length <= 0)     {
        return env;
    }
    n = local_vec_length;
    ad_var_7 = (MPI_Datatype )6;
    ad_var_8 = (ad_MPI_Op )102;
    ad_MPI_Allreduce( &n,  &Nsum, 1, ad_var_7, ad_var_8, comm);
    env->global_vec_length = Nsum;
    if (Nsum != global_vec_length)     {
        printf("PVecInitMPI-- Sum of local vector lengths differs from input global length. \n\n");
        ad_PVecFreeMPI(env);
        ad_var_9 = (void  * )0;
        return ad_var_9;
    }
    return env;
}
void   ad_PVecFreeMPI(void   *machEnv) {
machEnvType  env;
machEnvType  ad_var_0;
void   *ad_var_1;
    ad_var_0 = (machEnvType )machEnv;
    env = ad_var_0;
    ad_var_1 = (void  * )0;
    if (env == ad_var_1)     {
        return;
    }
    if ( !env->init_by_user)     {
        MPI_Finalize();
    }
    free(machEnv);
}
ad_N_Vector  ad_N_VNew(integer  Ntotal,machEnvType  machEnv) {
ad_N_Vector  v;
int  N_local, N_global;
int  i, j, ns;
ad_N_Vector  *ptr;
void   *ad_var_0, *ad_var_1, *ad_var_2, *ad_var_3, *ad_var_5, *ad_var_6, *ad_var_7, *ad_var_9, *ad_var_10, *ad_var_11, *ad_var_13, *ad_var_14, *ad_var_16, *ad_var_18, *ad_var_20, *ad_var_21;
ad_N_Vector  ad_var_4, *ad_var_12, ad_var_17;
DERIV_TYPE  *ad_var_8;
int  ad_var_15, ad_var_19;
    if (Ntotal <= 0)     {
        ad_var_0 = (void  * )0;
        return ad_var_0;
    }
    ad_var_1 = (void  * )0;
    if (machEnv == ad_var_1)     {
        ad_var_2 = (void  * )0;
        return ad_var_2;
    }
    N_local = machEnv->local_vec_length;
    N_global = machEnv->global_vec_length;
    ns = Ntotal / N_global - 1;
    ad_var_3 = malloc( sizeof *v);
    ad_var_4 = (ad_N_Vector )ad_var_3;
    v = ad_var_4;
    ad_var_5 = (void  * )0;
    if (v == ad_var_5)     {
        ad_var_6 = (void  * )0;
        return ad_var_6;
    }
    ad_var_7 = malloc(((1 + ns) * N_local) *  sizeof (DERIV_TYPE ));
    ad_var_8 = (DERIV_TYPE * )ad_var_7;
    v->data = ad_var_8;
    ad_var_9 = (void  * )0;
    if (v->data == ad_var_9)     {
        free(v);
        ad_var_10 = (void  * )0;
        return ad_var_10;
    }
    v->length = N_local * (1 + ns);
    v->global_length = N_global * (1 + ns);
    v->machEnv = machEnv;
    ad_var_11 = malloc((1 + ns) *  sizeof (ad_N_Vector ));
    ad_var_12 = (ad_N_Vector * )ad_var_11;
    ptr = ad_var_12;
    ad_var_13 = (void  * )0;
    if (ptr == ad_var_13)     {
        free(v->data);
        free(v);
        ad_var_14 = (void  * )0;
        return ad_var_14;
    }
    for (i = 0;     i <= ns;     )    {
        ad_var_16 = malloc( sizeof **ptr);
        ad_var_17 = (ad_N_Vector )ad_var_16;
        ptr[i] = ad_var_17;
        ad_var_18 = (void  * )0;
        if (ptr[i] == ad_var_18)         {
            for (j = i - 1;             j >= 0;             )            {
                free(ptr[j]);
                ad_var_19 = j--;
            }
            free(ptr);
            free(v->data);
            free(v);
            ad_var_20 = (void  * )0;
            return ad_var_20;
        }
        (ptr[i])->data = v->data + i * N_local;
        (ptr[i])->length = N_local;
        (ptr[i])->global_length = N_global;
        (ptr[i])->machEnv = machEnv;
        ad_var_21 = (void  * )0;
        (ptr[i])->subptr = ad_var_21;
        ad_var_15 = i++;
    }
    v->subptr = ptr;
    return v;
}
void   ad_N_VFree(ad_N_Vector  x) {
int  Ntotal, N_global;
int  i, ns;
machEnvType  machEnv;
ad_N_Vector  *ptr;
machEnvType  ad_var_0;
ad_N_Vector  *ad_var_1;
int  ad_var_2;
    Ntotal = x->global_length;
    ad_var_0 = (machEnvType )x->machEnv;
    machEnv = ad_var_0;
    N_global = machEnv->global_vec_length;
    ns = Ntotal / N_global - 1;
    ad_var_1 = (ad_N_Vector * )x->subptr;
    ptr = ad_var_1;
    for (i = 0;     i <= ns;     )    {
        free(ptr[i]);
        ad_var_2 = i++;
    }
    free(x->subptr);
    free(x->data);
    free(x);
    return;
}
